%%
%   function centerPopUp()
%
%   This function determines the position coordinates for the popup to be
%   positioned in the center of the screen. The output of the function 
%   OUTPUTFUNCTION can be used directly as follows:
%                                   set(figure,'Position',OUTPUTFUNCTION
%
%
%   Input:  hDesiredSize:       The Desired size for the popup screen 
%                               [horizontal,vertical]
%
%   Output: Position:           Position is the center of the screen.
%                               [horizontal,vertical,hDesiredSize]
%
%%

function Position = centerPopUp(hDesiredSize)
global data

% Extract size of user screen from general struct data
screensize = data.screensize;

% Determine the center of the screen using the desired popup size
Position = [(screensize(1)-hDesiredSize(1))/2,...
    (screensize(2)-hDesiredSize(2))/2, hDesiredSize(1), hDesiredSize(2)];

return