%%
%
%
%%
function discretisationsettings(action,hObject,eventdata,handles)
global data

set(data.handles.defineElement,'string','Defining Mapping Settings'); drawnow;

h = figure;
data.discretisation.h = h;

hDesiredSize = [550, 260];
set(h,'Resize','off','MenuBar','none','ToolBar','none','NumberTitle','off','Name',...
    ['Mapping Settings'],'Position',centerPopUp(hDesiredSize),...
    'Units','normalized','Color',[.9 .9 .9],'WindowStyle','modal');


% Define text
uicontrol(h,'Style','text','String','Frequency','Units','normalized',...
    'Backgroundcolor',[.9 .9 .9],'Position',[.05 .675 .2 .1]);
uicontrol(h,'Style','text','String','Magnitude','Units','normalized',...
    'Backgroundcolor',[.9 .9 .9],'Position',[.05 .5125 .2 .1]);
uicontrol(h,'Style','text','String','Phase','Units','normalized',...
    'Backgroundcolor',[.9 .9 .9],'Position',[.05 .375 .2 .1]);
uicontrol(h,'Style','text','String','Number of points','Units','normalized',...
    'Backgroundcolor',[.9 .9 .9],'Position',[.25 .83 .1 .11]);
uicontrol(h,'Style','text','String','Min','Units','normalized',...
    'Backgroundcolor',[.9 .9 .9],'Position',[.42 .83 .1 .11]);
uicontrol(h,'Style','text','String','Max','Units','normalized',...
    'Backgroundcolor',[.9 .9 .9],'Position',[.62 .83 .1 .11]);
uicontrol(h,'Style','text','String','Units','Units','normalized',...
    'Backgroundcolor',[.9 .9 .9],'Position',[.81 .83 .1 .11]);


% Define inputs (n.o. points, min, max)

data.discretisation.temp.nFreq = uicontrol(h,'Style','edit',...
    'Units','normalized','String',num2str(data.discretisation.nFreq),...
    'Backgroundcolor',[1 1 1],'Position',[.25 .7 .1 .1]);
data.discretisation.temp.nMag = uicontrol(h,'Style','edit','UserData',data.discretisation.nMag,...
    'Units','normalized','String',num2str(data.discretisation.nMag),...
    'Backgroundcolor',[1 1 1],'Position',[.25 .55 .1 .1]);
data.discretisation.temp.nPhase = uicontrol(h,'Style','edit','UserData',data.discretisation.nPhase,...
    'Units','normalized','String',num2str(data.discretisation.nPhase),...
    'Backgroundcolor',[1 1 1],'Position',[.25 .4 .1 .1]);


data.discretisation.temp.minFreq = uicontrol(h,'Style','edit','UserData',data.discretisation.minFreq,...
    'Units','normalized','String',num2str(data.discretisation.minFreq),...
    'Backgroundcolor',[1 1 1],'Position',[.4 .7 .15 .1]);
data.discretisation.temp.minMag = uicontrol(h,'Style','edit','UserData',data.discretisation.minMag,...
    'Units','normalized','String',num2str(data.discretisation.minMag),...
    'Backgroundcolor',[1 1 1],'Position',[.4 .55 .15 .1]);
data.discretisation.temp.minPhase = uicontrol(h,'Style','edit','UserData',data.discretisation.minPhase,...
    'Units','normalized','String',num2str(data.discretisation.minPhase),...
    'Backgroundcolor',[1 1 1],'Position',[.4 .4 .15 .1]);


data.discretisation.temp.maxFreq = uicontrol(h,'Style','edit','UserData',data.discretisation.maxFreq,...
    'Units','normalized','String',num2str(data.discretisation.maxFreq),...
    'Backgroundcolor',[1 1 1],'Position',[.6 .7 .15 .1]);
data.discretisation.temp.maxMag = uicontrol(h,'Style','edit','UserData',data.discretisation.maxMag,...
    'Units','normalized','String',num2str(data.discretisation.maxMag),...
    'Backgroundcolor',[1 1 1],'Position',[.6 .55 .15 .1]);
data.discretisation.temp.maxPhase = uicontrol(h,'Style','edit','UserData',data.discretisation.maxPhase,...
    'Units','normalized','String',num2str(data.discretisation.maxPhase),...
    'Backgroundcolor',[1 1 1],'Position',[.6 .4 .15 .1]);

% Define units
data.discretisation.temp.unitsFreq = uicontrol(h,'Style','popupmenu','String',{'Hz','rad/s'},...
    'Units','normalized','Backgroundcolor',[1 1 1],'Position',[.8 .7 .15 .1],...
    'Value',data.discretisation.unitsFreq.Value);
data.discretisation.temp.unitsMag = uicontrol(h,'Style','popupmenu','String',{'dB'},...
    'Units','normalized','Backgroundcolor',[1 1 1],'Position',[.8 .55 .15 .1],...
    'Value',data.discretisation.unitsMag.Value);
data.discretisation.temp.unitsPhase = uicontrol(h,'Style','popupmenu','String',{'degree','rad'},...
    'Units','normalized','Backgroundcolor',[1 1 1],'Position',[.8 .4 .15 .1],...
    'Value',data.discretisation.unitsPhase.Value);

% Check advanced method
data.discretisation.temp.discretisationmethod = uicontrol(h,'Style','checkbox',...
    'String','Use multiple-rectangular stability-mapping method','Value',data.discretisation.discretisationmethod,...
    'Units','normalized','Position',[.15 .25 .6 .1],'Backgroundcolor',[.9 .9 .9]);

% Declaration Cancel button
hreset = uicontrol(h,'Style','pushbutton','String','Reset','Units','normalized',...
    'Position',[.1 .06 .15 .1],'Backgroundcolor',data.colourbutton,'FontSize',[11],...
    'Callback',@resetDiscretisation);

hcompletereset = uicontrol(h,'Style','pushbutton','String','Initialize','Units','normalized',...
    'Position',[.3 .06 .15 .1],'Backgroundcolor',data.colourbutton,'FontSize',[11],...
    'Callback',@completeResetDiscretisation);

% Declaration Cancel button
hcancel = uicontrol(h,'Style','pushbutton','String','Cancel','Units','normalized',...
    'Position',[.5 .06 .15 .1],'Backgroundcolor',data.colourbutton,'FontSize',[11],...
    'Callback','global data; closePopUp(data.discretisation.h); clear data;');

% Declaration Define button
hdefine = uicontrol(h,'Style','pushbutton','String','Define','Units','normalized',...
    'Position',[.7 .06 .15 .1],'Backgroundcolor',data.colourbutton,'FontSize',[11],...
    'Enable','on','Callback',@defineDiscretisationValues);


return

function defineDiscretisationValues(varargin)
global data

initDiscretisation('save');

closePopUp(data.discretisation.h)

return

function resetDiscretisation(varargin)

initDiscretisation('reset');

return

function completeResetDiscretisation(varargin)

initDiscretisation('completereset');

return
