



%%
%  extractHybrid computes the four hybrid matrices dependent on
%  freq,magnitude and phase
%
%%

function [Y11 Y12 Y21 Y22] = extractY(Z,C,s)

% Hybrid elements are defined for positions
% Ze = Z{1};
% Zh = Z{2};
sZs = Z{3};
sZm = Z{4};
clear Z
C1 = C{1};
C2 = C{2};
C3 = C{3};
C4 = C{4};
C5 = C{5};
C6 = C{6};
Cs = C{7};
Cm = C{8};

clear C
D1 = (sZm + Cm).^-1.*C4;
D2 = (sZm + Cm).^-1.*(1+C6);
D3 = (sZm + Cm).^-1.*C2;

Y21 = (sZs+Cs+C1.*D1).^-1.*(C1.*D2 + C3);
Y22 = -(sZs+Cs+C1.*D1).^-1.*(C1.*D3+1+C5);
Y11 = -D1.*Y21 + D2;
Y12 = D1.*Y22 + D3;

return

