%%
%
%
%%

function initDiscretisation(varargin)
global data

discParam = {'nFreq','nMag','nPhase','minFreq','minMag','minPhase',...
    'maxFreq','maxMag','maxPhase','unitsFreq','unitsMag',...
    'unitsPhase'};
discValue = [150,150,200,1,-40,-180,100,40,180];
discUnitsValue = [1,1,1];
discString = {'Hz','dB','degree'};

n = length(discParam);
m = length(discValue);
       
switch varargin{1}
    case 'init'   
        
        for i = 1:1:n
            if(i <= m)
                data.discretisation.(discParam{i}) = discValue(i);
            else
                data.discretisation.(discParam{i}).Value = discUnitsValue(i-m);
                data.discretisation.(discParam{i}).String = {discString{i-m}};
            end
        end
        set(data.handles.MagPhaseperSlider,'Value',log10(data.discretisation.minFreq));
        set(data.handles.MagPhaseperSlider,'Min',log10(data.discretisation.minFreq));
        set(data.handles.MagPhaseperSlider,'Max',log10(data.discretisation.maxFreq));
        
        data.discretisation.discretisationmethod = 0;    
        set(data.handles.resolution,'Visible','on','String',...
        [num2str((discValue(8)-discValue(5))/discValue(2)),' ',discString{2}, ' in Magnitude and ',...
        num2str((discValue(9)-discValue(6))/discValue(3)),' ',discString{3},' in Phase']);

    case 'reset'
        for i = 1:1:n
            if(i <= m)
                set(data.discretisation.temp.(discParam{i}),'String',...
                    data.discretisation.(discParam{i}));
            else
                set(data.discretisation.temp.(discParam{i}),'Value',...
                    data.discretisation.(discParam{i}).Value);
            end
        end
        set(data.discretisation.temp.discretisationmethod,'Value',data.discretisation.discretisationmethod);
        
    case 'completereset'        
        for i = 1:1:n
            if(i <= m)
                set(data.discretisation.temp.(discParam{i}),'String',discValue(i));
            else
                set(data.discretisation.temp.(discParam{i}),'Value',discUnitsValue(i-m));
            end
        end
        set(data.discretisation.temp.discretisationmethod,'Value',0);
  
    case 'save'
        for i = 1:1:n
            if(i <= m)
                data.discretisation.(discParam{i}) =...
                    str2num(get(data.discretisation.temp.(discParam{i}),'String'));
            else
                data.discretisation.(discParam{i}).Value =...
                    get(data.discretisation.temp.(discParam{i}),'Value');
                string = cell(get(data.discretisation.temp.(discParam{i}),'String'));                
                data.discretisation.(discParam{i}).String{1} =...
                    string{data.discretisation.(discParam{i}).Value};
            end
        end
        data.plot.unitsFreq.Value = data.discretisation.unitsFreq.Value;
        
        data.discretisation.discretisationmethod = get(data.discretisation.temp.discretisationmethod,'Value');
        
        set(data.handles.resolution,'String',...
        [num2str((data.discretisation.maxMag-data.discretisation.minMag)/data.discretisation.nMag),' ',data.discretisation.unitsMag.String{1}, ' in Magnitude and ',...
        num2str((data.discretisation.maxPhase-data.discretisation.minPhase)/data.discretisation.nPhase),' ',data.discretisation.unitsPhase.String{1},' in Phase'])
           
end

return

