%%
%
%
%%
function plotDiagram(action,hObject,eventdata,handles)
global data
if(data.stepOfAction(1,1) > 1)
    step = data.stepOfAction(1,1);
    nostep = data.stepOfAction(1,2);
else
    step = 1;
    nostep = 4;
end

delete(allchild(data.handles.magnitudeplot));
delete(allchild(data.handles.phaseplot));

%% Plot MPOmega
set(data.handles.defineElement,'string',...
    ['Plot Mag.-Phase per Freq. diagram (Step ',num2str(step),' of ',num2str(nostep),').']); drawnow;
step = step + 1;

set(data.handles.MagPhaseperSlider,'Min',log10(data.parameters.Freq(1)));
set(data.handles.MagPhaseperSlider,'Max',log10(data.parameters.Freq(end)));
set(data.handles.MagPhaseperSlider,'Value',log10(data.parameters.Freq(1)));

plotMPOmega('plot2D',hObject,eventdata,handles);

%% Plot Bode diagram

if(data.discretisation.discretisationmethod == 0)
    step = plot2DBodediagram(action,hObject,eventdata,handles,step,nostep);
else
    step = plot2DBodediagramNewMethod(action,hObject,eventdata,handles,step,nostep);
end

set(data.handles.magnitudeplot,'layer','top');
set(data.handles.phaseplot,'layer','top');
set(data.handles.MagPhaseperOmega,'layer','top');

%% Plotting Controller
set(data.handles.defineElement,'string',...
    ['Plotting Controller (Step ',num2str(step),' of ',num2str(nostep),').']); drawnow;
data.stepOfAction(1,1) = step + 1;

designController('initial',hObject,eventdata,handles);

plotController();

if(data.stepOfAction(1,1) <= 5 || data.stepOfAction(1,1) > 9)
    data.stepOfAction(1,1) = 1;
    set(data.handles.defineElement,'string','');drawnow;
end

%% Plotting kind of mapping
Reversed = data.stabilityproperties.rev;

axes(data.handles.magnitudeplot)
Ylimit = get(data.handles.magnitudeplot,'YLim');
for iW = 1:1:length(data.parameters.Freq)
    if(Reversed{iW} == 1)
        plot(data.parameters.Freq(iW),Ylimit(2),'or','MarkerSize',3,'Linewidth',3);
    end
end
axes(data.handles.phaseplot)
Ylimit = get(data.handles.phaseplot,'YLim');
for iW = 1:1:length(data.parameters.Freq)
    if(Reversed{iW} == 1)
        plot(data.parameters.Freq(iW),Ylimit(2),'or','MarkerSize',3,'Linewidth',3);
    end
end
%% Saving external figure
if(data.plot.externalPlot == 1)
    h = figure;
    h1 = subplot(211);
    xlabel(strcat('Frequency (',data.plot.unitsFreq.String,')'))
    ylabel(strcat('Magnitude (',data.plot.unitsMag.String,')'));
    h2 = subplot(212);
    xlabel(strcat('Frequency (',data.plot.unitsFreq.String,')'))
    ylabel(strcat('Phase (',data.plot.unitsPhase.String,')'))
    copyobj(get(data.handles.magnitudeplot,'children'),h1);
    set(h1,...%'XTickLabel',get(data.handles.magnitudeplot,'XTickLabel'),...
        'XTick',get(data.handles.magnitudeplot,'XTick'),...
        'XLim',get(data.handles.magnitudeplot,'XLim'),...
        'XScale',get(data.handles.magnitudeplot,'XScale'),...
        'YTickLabel',get(data.handles.magnitudeplot,'YTickLabel'),...
        'YTick',get(data.handles.magnitudeplot,'YTick'),...
        'YLim',get(data.handles.magnitudeplot,'YLim'),...
        ...%            'XMinorGrid','on',...
        'box','on','layer','top');
    %% Plotting kind of mapping
    
    Ylimit = get(data.handles.magnitudeplot,'YLim');
    for iW = 1:1:length(data.parameters.Freq)
        if(Reversed{iW} == 1)
            plot(data.parameters.Freq(iW),Ylimit(2),'or','MarkerSize',3,'Linewidth',3);
        end
    end
    copyobj(get(data.handles.phaseplot,'children'),h2);
    set(h2,...%'XTickLabel',get(data.handles.phaseplot,'XTickLabel'),...
        'XTick',get(data.handles.phaseplot,'XTick'),...
        'XLim',get(data.handles.phaseplot,'XLim'),...
        'XScale',get(data.handles.phaseplot,'XScale'),...
        'XColor',get(data.handles.phaseplot,'XColor'),...
        'YTickLabel',get(data.handles.phaseplot,'YTickLabel'),...
        'YTick',get(data.handles.phaseplot,'YTick'),...
        'YLim',get(data.handles.phaseplot,'YLim'),...
        ...%             'XMinorGrid','on',.....
        'box','on','layer','top');
    Ylimit = get(data.handles.phaseplot,'YLim');
    for iW = 1:1:length(data.parameters.Freq)
        if(Reversed{iW} == 1)
            plot(data.parameters.Freq(iW),Ylimit(2),'or','MarkerSize',3,'Linewidth',3);hold on;
        end
    end
    
end
return

function step = plot2DBodediagramNewMethod(action,hObject,eventdata,handles,step,nostep)
global data

Freq  = data.parameters.Freq;
Mag   = data.parameters.Mag;
Phase = data.parameters.Phase;

nFreq = length(Freq);

[scaleMag, gainFreq, scalePhase, gainPhase] = resetGainsScales();

axes(data.handles.magnitudeplot)

data.plot.scaleMag2D = scaleMag;
data.plot.scalePhase2D = scalePhase;
set(data.handles.magnitudeplot,'YLim',[scaleMag(1),scaleMag(end)],'YTick',scaleMag,...
    'XLim',gainFreq.*[Freq(1) Freq(end)])%,'XMinorGrid','on')

data.plot.FLim = get(data.handles.magnitudeplot,'XLim');

xTickCur = get(data.handles.magnitudeplot,'XTick');
if(isempty(xTickCur))
    xTickCur = data.plot.FLim;
end
if(xTickCur(end) < data.plot.FLim(end))
    data.plot.scaleFreq2D = [xTickCur,data.plot.FLim(end)];
else
    data.plot.scaleFreq2D = xTickCur;
end
set(data.handles.magnitudeplot,'XTick',data.plot.scaleFreq2D);

ylabel(['Magnitude [',data.plot.unitsMag.String{1},']']);
xlabel(['Frequency [',data.plot.unitsFreq.String{1},']']);

axes(data.handles.phaseplot)

set(data.handles.phaseplot,'YLim',[scalePhase(1),scalePhase(end)],'YTick',scalePhase,...
    'XLim',gainFreq.*[Freq(1) Freq(end)],'XTick',data.plot.scaleFreq2D);%,'XMinorGrid','on')

xlabel(['Frequency [',data.plot.unitsFreq.String{1},']']);
ylabel(['Phase [',data.plot.unitsPhase.String{1},']']);

MRK = data.plotColour;

stableMag = data.stabilityproperties.stableMag;
unstableMag = data.stabilityproperties.unstableMag;
stablePhase = data.stabilityproperties.stablePhase;
unstablePhase = data.stabilityproperties.unstablePhase;
consMag = data.stabilityproperties.consMag;
consPhase = data.stabilityproperties.consPhase;

for iW = 1:1:nFreq
    set(data.handles.defineElement,'string',...
        ['Plotting: 2D Bode diagram (f = ',num2str(Freq(iW)),' ',data.plot.unitsFreq.String{1},')  ',...
        '(Step ',num2str(step),' of ',num2str(nostep),').']); drawnow;
    
    axes(data.handles.magnitudeplot)
    
    iM = 1;
    while iM <= length(consMag{iW})-1
        semilogx(gainFreq.*[Freq(iW), Freq(iW)],...
            [consMag{iW}(iM) consMag{iW}(iM+1)],'Color',MRK(2,:),'LineWidth',3);hold on;
        iM = iM + 2;
    end
    iM = 1;
    while iM <= length(stableMag{iW})-1
        semilogx(gainFreq.*[Freq(iW), Freq(iW)],...
            [stableMag{iW}(iM) stableMag{iW}(iM+1)],'Color',MRK(1,:),'LineWidth',3);hold on;
        iM = iM + 2;
    end
    iM = 1;
    while iM <= length(unstableMag{iW})-1
        semilogx(gainFreq.*[Freq(iW), Freq(iW)],...
            [unstableMag{iW}(iM) unstableMag{iW}(iM+1)],'Color',[1 1 1],'LineWidth',3);hold on;
        iM = iM + 2;
    end
    axes(data.handles.phaseplot)
    iP = 1;
    while iP <= length(consPhase{iW})-1
        semilogx(gainFreq.*[Freq(iW), Freq(iW)],...
            [consPhase{iW}(iP) consPhase{iW}(iP+1)],'Color',MRK(2,:),'LineWidth',3);hold on;
        iP = iP + 2;
    end
    iP = 1;
    while iP <= length(stablePhase{iW})-1
        semilogx(gainFreq.*[Freq(iW), Freq(iW)],...
            [stablePhase{iW}(iP) stablePhase{iW}(iP+1)],'Color',MRK(1,:),'LineWidth',3);hold on;
        iP = iP + 2;
    end
    iP = 1;
    while iP <= length(unstablePhase{iW})-1
        semilogx(gainFreq.*[Freq(iW), Freq(iW)],...
            [unstablePhase{iW}(iP) unstablePhase{iW}(iP+1)],'Color',[1 1 1],'LineWidth',3);hold on;
        iP = iP + 2;
    end
    
end

step = step + 1;
return

function step = plot2DBodediagram(action,hObject,eventdata,handles,step,nostep)
global data;

Freq  = data.parameters.Freq;
Mag   = data.parameters.Mag;
Phase = data.parameters.Phase;

nFreq = length(Freq);

NTRVec = data.stabilityproperties.NTR;
MlowVec = data.stabilityproperties.Mlow;
PlowVec = data.stabilityproperties.Plow;
MuppVec = data.stabilityproperties.Mupp;
PuppVec = data.stabilityproperties.Pupp;
revVec = data.stabilityproperties.rev;
Freq = data.parameters.Freq;

[scaleMag, gainFreq, scalePhase, gainPhase] = resetGainsScales();

MRK = data.plotColour;

Plotdata = struct;
Plotdata.FreqMag = {};
Plotdata.FreqPhase = {};

for iW = 1:1:nFreq
    rev = revVec{iW};
    NTR = NTRVec{iW};
    MLOW = MlowVec{iW};
    PLOW = PlowVec{iW};
    MUPP = MuppVec{iW};
    PUPP = PuppVec{iW};
    iPlotFreqMag = 1;
    iPlotFreqPhase = 1;
    f = Freq(iW);
    
    if rev == 0 || rev == 1
        % There are unstable and stable areas
        for iMrk = [2 1];% For inner and outer rectangle
            if rev == 1
                % Reversed case
                iMrk2 = iMrk*-1+3;
            else
                iMrk2 = iMrk;
            end
            Ntr = NTR(iMrk2);
            if Ntr > 0
                Mlow = MLOW(1,iMrk2);
                Mupp = MUPP(1,iMrk2);
                Plow = PLOW(1:Ntr,iMrk2);
                Pupp = PUPP(1:Ntr,iMrk2);
            end
            
            % Plot results for normal case (unconditionally stable/passive combos)
            if rev == 0
                if Mlow > Mag(1)
                    Plotdata.FreqMag{iPlotFreqMag} = [f,f,Mag(1)-10,Mlow,MRK(iMrk,:)];
                    iPlotFreqMag = iPlotFreqMag + 1;
                end
                if Mupp < Mag(end)
                    Plotdata.FreqMag{iPlotFreqMag}  = [f,f,Mupp,Mag(end)+10,MRK(iMrk,:)];
                    iPlotFreqMag = iPlotFreqMag + 1;
                end
                
                if Plow(1) > Phase(1)
                    Plotdata.FreqPhase{iPlotFreqPhase} = [f,f,Phase(1)-10,Plow(1),MRK(iMrk,:)];
                    iPlotFreqPhase = iPlotFreqPhase + 1;
                end
                if Pupp(end) < Phase(end)
                    Plotdata.FreqPhase{iPlotFreqPhase} = [f,f,Pupp(end),Phase(end)+10,MRK(iMrk,:)];
                    iPlotFreqPhase = iPlotFreqPhase + 1;
                end
                for iP = 2:Ntr
                    Plotdata.FreqPhase{iPlotFreqPhase} = [f,f,Pupp(iP-1),Plow(iP),MRK(iMrk,:)];
                    iPlotFreqPhase = iPlotFreqPhase + 1;
                end
                
                % Plot results for reversed case (unconditionally unstable/active combos)
            elseif rev == 1
                
                Plotdata.FreqMag{iPlotFreqMag}  = [f,f,Mlow,Mupp,MRK(iMrk,:)];
                iPlotFreqMag = iPlotFreqMag + 1;
                
                dFreq = (Freq(2)/Freq(1)-1)/2+1;
                
                Plotdata.FreqMag{iPlotFreqMag} = [f/dFreq,f*dFreq,Mag(1),Mag(1),2];
                iPlotFreqMag = iPlotFreqMag + 1;
                
                for iP = 1:Ntr
                    Plotdata.FreqPhase{iPlotFreqPhase} = [f,f,Plow(iP),Pupp(iP),MRK(iMrk,:)];
                    iPlotFreqPhase = iPlotFreqPhase + 1;
                end
                
                Plotdata.FreqPhase{iPlotFreqPhase} = [f/dFreq,f*dFreq,Phase(1),Phase(1),2];
                iPlotFreqPhase = iPlotFreqPhase + 1;
            end
            
            data.plot.Data.FreqMag2D{iW} = Plotdata.FreqMag;
            data.plot.Data.FreqPhase2D{iW} = Plotdata.FreqPhase;
            
        end
    end
    
    if(rev == -1)
        %        data.plot.Data.FreqMag2D{iW} = {[f,f,Mag(1),Mag(end),MRK(iMrk,:)]};
        %        data.plot.Data.FreqPhase2D{iW} = {[f,f,Phase(1),Phase(end),MRK(iMrk,:)]};
        data.plot.Data.FreqMag2D{iW} = {[f,f,Mag(1),Mag(end),MRK(1,:)]};
        data.plot.Data.FreqPhase2D{iW} = {[f,f,Phase(1),Phase(end),MRK(1,:)]};
    end
    
end

Mag = data.plot.Data.FreqMag2D;
Phase = data.plot.Data.FreqPhase2D;
nMag = length(Mag);
nPhase = length(Phase);


%% Plotting
set(data.handles.defineElement,'string',...
    ['Plotting: 2D Bode Magnitude diagram (Step ',num2str(step),' of ',num2str(nostep),').']); drawnow;
step = step + 1;

set(data.handles.plotfrequencyin,'Value',data.plot.unitsFreq.Value);
set(data.handles.plotphasein,'Value',data.plot.unitsPhase.Value);
set(data.handles.plotmagnitudein,'Value',data.plot.unitsMag.Value);

axes(data.handles.magnitudeplot)
plot = [0 0 0 0 0 0 0];
for i = 1:1:nMag
    if(~isempty(Mag{i}))
        for j = 1:1:length(Mag{i});
            for k = 1:1:length(Mag{i})
                plot = Mag{i}{j};
                if(length(plot) == 5)
                    semilogx(gainFreq*[plot(1),plot(2)],[plot(3),plot(4)],'-k');hold on;
                else
                    semilogx(gainFreq*[plot(1),plot(2)],[plot(3),plot(4)],'Color',plot(5:end),'LineWidth',3);hold on;
                end
            end
        end
    end
end

data.plot.scaleMag2D = scaleMag;
data.plot.scalePhase2D = scalePhase;
set(data.handles.magnitudeplot,'YLim',[scaleMag(1),scaleMag(end)],'YTick',scaleMag,...
    'XLim',gainFreq.*[Freq(1) Freq(end)])
data.plot.FLim = get(data.handles.magnitudeplot,'XLim');

xTickCur = get(data.handles.magnitudeplot,'XTick');
if(isempty(xTickCur))
    xTickCur = data.plot.FLim;
end
if(xTickCur(end) < data.plot.FLim(end))
    data.plot.scaleFreq2D = [xTickCur,data.plot.FLim(end)];
else
    data.plot.scaleFreq2D = xTickCur;
end
set(data.handles.magnitudeplot,'XTick',data.plot.scaleFreq2D);%,'XMinorGrid','on');

ylabel(['Magnitude [',data.plot.unitsMag.String{1},']']);
xlabel(['Frequency [',data.plot.unitsFreq.String{1},']']);


set(data.handles.defineElement,'string',...
    ['Plotting: 2D Bode Phase diagram (Step ',num2str(step),' of ',num2str(nostep),').']); drawnow;
step = step + 1;

axes(data.handles.phaseplot)

plot = [0 0 0 0 0 0 0];
for i = 1:1:nPhase
    if(~isempty(Phase{i}))
        for j = 1:1:length(Phase{i});
            for k = 1:1:length(Phase{i})
                plot = Phase{i}{j};
                if(length(plot) == 5)
                    semilogx(gainFreq*[plot(1),plot(2)],gainPhase*[plot(3),plot(4)],'-k');hold on;
                else
                    semilogx(gainFreq*[plot(1),plot(2)],gainPhase*[plot(3),plot(4)],'Color',plot(5:end),'LineWidth',3);hold on;
                end
            end
        end
    end
end

set(data.handles.phaseplot,'YLim',[scalePhase(1),scalePhase(end)],'YTick',scalePhase,...
    'XLim',gainFreq.*[Freq(1) Freq(end)],'XTick',data.plot.scaleFreq2D)%,...
%'XMinorGrid','on')

xlabel(['Frequency [',data.plot.unitsFreq.String{1},']']);
ylabel(['Phase [',data.plot.unitsPhase.String{1},']']);



return

function [scaleMag, gainFreq, scalePhase, gainPhase] = resetGainsScales()
global data

scaleMag = data.plot.scaleMag2D;
if(data.discretisation.unitsFreq.Value == 1)
    if(data.plot.unitsFreq.Value == 1)
        gainFreq = 1;
    else
        gainFreq = 2*pi;
    end
else
    if(data.plot.unitsFreq.Value == 1)
        gainFreq = 1/(2*pi);
    else
        gainFreq = 1;
    end
end

if(data.discretisation.unitsPhase.Value == 1)
    if(data.plot.unitsPhase.Value == 1)
        gainPhase = 1;
        scalePhase = data.plot.scalePhase2D;
    else
        gainPhase = (2*pi)/360;
        scalePhase = data.plot.scalePhase2D.*2.*pi./360;
    end
else
    if(data.plot.unitsPhase.Value == 1)
        gainPhase = 360/(2*pi);
        scalePhase = data.plot.scalePhase2D.*360./(2.*pi);
    else
        gainPhase = 1;
        scalePhase = data.plot.scalePhase2D;
    end
end


return

