%%
%
%
%%

function plotOptions(action,hObject,eventdata,handles)
global data

otherButtons('disable');
data.plot.Magcontroller = {};
data.plot.Phasecontroller = {};
data.plot.Pointcontroller = {};

switch action
    case 'plotfrequencyin'
        % Read Out Popup Menu
        unit = cellstr(get(hObject,'String'));
        unit = unit{get(hObject,'Value')};
        
        data.plot.unitsFreq.String{1} = unit;
        
        switch unit
            case 'Hz'
                data.plot.unitsFreq.Value = 1;
            case 'rad/s'
                data.plot.unitsFreq.Value = 2;
        end
        
        plotAll = 1;
    case 'plotmagnitudein'
        unit = cellstr(get(hObject,'String'));
        unit = unit{get(hObject,'Value')};
        
        data.plot.unitsMag.String{1} = unit;
        switch unit
            case 'dB'
                data.plot.unitsMag.Value = 1;
        end
        
        plotAll = 1;
    case 'plotphasein'
        unit = cellstr(get(hObject,'String'));
        unit = unit{get(hObject,'Value')};
        
        data.plot.unitsPhase.String{1} = unit;
        
        switch unit
            case 'degree'
                data.plot.unitsPhase.Value = 1;
            case 'radians'
                data.plot.unitsPhase.Value = 2;
        end
        
        plotAll = 1;
    case 'externalplot'
        
        if(data.plot.externalPlot == 1)
            data.plot.externalPlot = 0;
            set(data.handles.externalplot,'Value',0);
        else
            data.plot.externalPlot = 1;
            set(data.handles.externalplot,'Value',1);
            if (data.mapped == 1)
                h = figure;
                h1 = subplot(211);
                xlabel(strcat('Frequency (',data.plot.unitsFreq.String,')'))
                ylabel(strcat('Magnitude (',data.plot.unitsMag.String,')'));
                h2 = subplot(212);
                xlabel(strcat('Frequency (',data.plot.unitsFreq.String,')'))
                ylabel(strcat('Phase (',data.plot.unitsPhase.String,')'))
                copyobj(get(data.handles.magnitudeplot,'children'),h1);
                set(h1,...%'XTickLabel',get(data.handles.magnitudeplot,'XTickLabel'),...
                    'XTick',get(data.handles.magnitudeplot,'XTick'),...
                    'XLim',get(data.handles.magnitudeplot,'XLim'),...
                    'XScale',get(data.handles.magnitudeplot,'XScale'),...
                    'YTickLabel',get(data.handles.magnitudeplot,'YTickLabel'),...
                    'YTick',get(data.handles.magnitudeplot,'YTick'),...
                    'YLim',get(data.handles.magnitudeplot,'YLim'),...
                    'box','on','layer','top');
                
                copyobj(get(data.handles.phaseplot,'children'),h2);
                set(h2,...%'XTickLabel',get(data.handles.phaseplot,'XTickLabel'),...
                    'XTick',get(data.handles.phaseplot,'XTick'),...
                    'XLim',get(data.handles.phaseplot,'XLim'),...
                    'XScale',get(data.handles.phaseplot,'XScale'),...
                    'XColor',get(data.handles.phaseplot,'XColor'),...
                    'YTickLabel',get(data.handles.phaseplot,'YTickLabel'),...
                    'YTick',get(data.handles.phaseplot,'YTick'),...
                    'YLim',get(data.handles.phaseplot,'YLim'),...
                    'box','on','layer','top');
                g = figure;
                xlabel(strcat('Phase (',data.plot.unitsPhase.String,')'))
                ylabel(strcat('Magnitude (',data.plot.unitsMag.String,')'));
                title(strcat('Frequency = ',get(data.handles.MPfreq,'String')));
                
                copyobj(get(data.handles.MagPhaseperOmega,'children'),gca);
                set(gca,'XTickLabel',get(data.handles.MagPhaseperOmega,'XTickLabel'),...
                    'XTick',get(data.handles.MagPhaseperOmega,'XTick'),...
                    'XLim',get(data.handles.MagPhaseperOmega,'XLim'),...
                    'XScale',get(data.handles.MagPhaseperOmega,'XScale'),...
                    'XColor',get(data.handles.MagPhaseperOmega,'XColor'),...
                    'YTickLabel',get(data.handles.MagPhaseperOmega,'YTickLabel'),...
                    'YTick',get(data.handles.MagPhaseperOmega,'YTick'),...
                    'YLim',get(data.handles.MagPhaseperOmega,'YLim'),...
                    'box','on','layer','top');
            end
            
        end
        
        plotAll = 0;
        
        
end



if(data.mapped == 1)
    if plotAll == 1
        plotDiagram(action,hObject,eventdata,handles);
        evaluateStability('final');
    end
    set(data.handles.unitpole,'String',data.plot.unitsFreq.String{1});
    set(data.handles.unitzero,'String',data.plot.unitsFreq.String{1});
end
otherButtons('enable');



return


